# -*- encoding : utf-8 -*-

class Admin::ProductCategoriesController < ApplicationController
	before_filter :auth_admin

	layout "admin"


	before_filter :find_product_categories


	def index 

	end


  def reorder

    i = 1
    
    
    params[:product_categories_ids].each do |id|
      

      product_category = ProductCategory.find(id)
      product_category.position = i
      puts i
      product_category.update_attributes :position => i
      
      i = i + 1
      
      
    end
    
		if params[:menu_id] and params[:menu_id] != "" and @menu = Menu.find(params[:menu_id])
			
      find_product_categories
    end
    
    flash[:success] = "Menus réorganisés avec succcès."
    
   
    
  end


	def cible
		@product_categories = ProductCategory.all

		render :layout => false
	end

	
	def new
		@product_category = ProductCategory.new(:parent_id => params[:parent_id])
    
    LangSite.all.each do |ls|
      @product_category.product_category_langs << ProductCategoryLang.new(:lang => ls.slug, :parent_id => params[:parent_id])
    end

	end

	def edit
		@product_category = ProductCategory.find(params[:id])
	end
  
	def show
		@product_category = ProductCategory.find(params[:id])
	end


	def create
		@product_category = ProductCategory.new(params.require(:product_category).permit!)


		if @product_category.save
      params[:parent_id] =@product_category.parent_id
      
			self.find_product_categories
			flash[:notice] = "La catégorie à été ajouté avec succès."
		

		else
			render :action => "new" 
		
		end
	
	end
	

	def update
		@product_category = ProductCategory.find(params[:id])

		
		
		
		if request.xhr?
			@product_category_parent = @product_category.parent if @product_category.parent
			@product_categories = ProductCategory.where(:parent_id => @product_category.parent_id).order(:position)
		end
	
		if params[:product_category][:parent_id] and params[:product_category][:parent_id] == "no-menu-selected"
			params[:product_category][:parent_id] = nil
		end
		
		@reorder = true if params[:reorder]
		

		
		
	
		
		
		respond_to do |format|
			if @product_category.update_attributes(params.require(:product_category).permit!)
				
				#ProductCategory.all.each do |mi|
				#	mi.set_permalink
				
				#end
			
				flash[:notice] = "Le menu à été modifié avec succès."
				format.html { redirect_to(admin_product_categories_path(:parent_id => @product_category.parent_id)) }
				if @reorder
					format.js { 
						
						render :action => "update" }
				else
					format.js { 
					   @product_category = ProductCategory.find(@product_category.id)
						render :action => "update_row" }
				end
			else
				
				flash[:error] = "Cet élément de menu n'a pas pu être déplacé. Vérifiez que son lien permanent n'éxiste pas déjà dans l'élément cible."
				if @reorder
					format.js { render :action => "update_reorder_failled" }
				else
					format.html { render :action => "edit" }
					format.js { render :action => "edit" }
				end
				
				
			end
		end
    
    
    
    

	end


	def destroy
		@product_category = ProductCategory.find(params[:id])
    params[:parent_id] = @product_category.parent_id
		@product_category.destroy
    find_product_categories
  
    flash[:notice] = "La catégorie à bien été supprimée."
	end
	
	
	protected
	
	def find_product_categories    
    params[:parent_id] = nil if !params[:parent_id] or params[:parent_id] == ""
			
		@product_category_parent = ProductCategory.find(params[:parent_id]) if params[:parent_id]
    
    
    @product_categories = ProductCategory.where(:parent_id => params[:parent_id]).order("position ASC")
		

	
  end
  
end
